{
********************************************************************************

SPackGui
Copyright (C) 2000-2012 Geoffray Levasseur <geoffray.levasseurbrandin@numericable.fr>.
http://www.geoffray-levasseur.org/

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

********************************************************************************

Description:
  Some colors declaration and manipulation along ListView and SPack

********************************************************************************
}
unit uListViewColors;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics, uSpackPackage;

var
  clUpdatablePackageFont: TColor;
  clOutdatedPackageFont: TColor;
  clPackageToInstallFont: TColor;
  clPackageToUpgradeFont: TColor;
  clPackageToRemoveFont: TColor;
  clUpdatablePackageBack: TColor;
  clOutdatedPackageBack: TColor;
  clPackageToInstallBack: TColor;
  clPackageToUpgradeBack: TColor;
  clPackageToRemoveBack: TColor;

procedure LoadColors;
procedure SaveColors;

//give colors depending on pkgstatus
procedure GetColorFromState(const State: TPkgState; out FG, BG: TColor);

implementation

uses
  uCommon, uStrings;

procedure LoadColors;
begin
  clUpdatablePackageFont := iniMain.ReadInteger(rsConfSectionListViewColors,
    rsConfNameUpdatablePackageFont, clGreen);
  clUpdatablePackageBack := iniMain.ReadInteger(rsConfSectionListViewColors,
    rsConfNameUpdatablePackageBack, clDefault);
  clOutdatedPackageFont := iniMain.ReadInteger(rsConfSectionListViewColors,
    rsConfNameOutdatedPackageFont, clRed);
  clOutdatedPackageBack := iniMain.ReadInteger(rsConfSectionListViewColors,
    rsConfNameOutdatedPackageBack, clDefault);
  clPackageToInstallFont := iniMain.ReadInteger(rsConfSectionListViewColors,
    rsConfNamePackageToInstallFont, clWhite);
  clPackageToInstallBack := iniMain.ReadInteger(rsConfSectionListViewColors,
    rsConfNamePackageToInstallBack, clGreen);
  clPackageToUpgradeFont := iniMain.ReadInteger(rsConfSectionListViewColors,
    rsConfNamePackageToUpgradeFont, clBlack);
  clPackageToUpgradeBack := iniMain.ReadInteger(rsConfSectionListViewColors,
    rsConfNamePackageToUpgradeBack, clYellow);
  clPackageToRemoveFont := iniMain.ReadInteger(rsConfSectionListViewColors,
    rsConfNamePackageToRemoveFont, clWhite);
  clPackageToRemoveBack := iniMain.ReadInteger(rsConfSectionListViewColors,
    rsConfNamePackageToRemoveBack, clRed);
end;

procedure SaveColors;
begin
  iniMain.WriteInteger(rsConfSectionListViewColors,
    rsConfNameUpdatablePackageFont, clUpdatablePackageFont);
  iniMain.WriteInteger(rsConfSectionListViewColors,
    rsConfNameUpdatablePackageBack, clUpdatablePackageBack);
  iniMain.WriteInteger(rsConfSectionListViewColors,
    rsConfNameOutdatedPackageFont, clOutdatedPackageFont);
  iniMain.WriteInteger(rsConfSectionListViewColors,
    rsConfNameOutdatedPackageBack, clOutdatedPackageBack);
  iniMain.WriteInteger(rsConfSectionListViewColors,
    rsConfNamePackageToInstallFont, clPackageToInstallFont);
  iniMain.WriteInteger(rsConfSectionListViewColors,
    rsConfNamePackageToInstallBack, clPackageToInstallBack);
  iniMain.WriteInteger(rsConfSectionListViewColors,
    rsConfNamePackageToUpgradeFont, clPackageToUpgradeFont);
  iniMain.WriteInteger(rsConfSectionListViewColors,
    rsConfNamePackageToUpgradeBack, clPackageToUpgradeBack);
  iniMain.WriteInteger(rsConfSectionListViewColors,
    rsConfNamePackageToRemoveFont, clPackageToRemoveFont);
  iniMain.WriteInteger(rsConfSectionListViewColors,
    rsConfNamePackageToRemoveBack, clPackageToRemoveBack);
end;

procedure GetColorFromState(const State: TPkgState; out FG, BG: TColor);
begin
  //keep widget set default color
  FG := clDefault;
  BG := clDefault;
  if psDeprecated in State then
  begin
    FG := clOutdatedPackageFont;
    Bg := clOutdatedPackageBack;
  end else
    if psUpdatable in State then
    begin
      FG := clUpdatablePackageFont;
      BG := clUpdatablePackageBack;
    end;
  //actions overide the previous declarations
  //get action to be done here if any
end;

end.

